
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <CfgVirgo.h>

void CfgVpmDisconnectionHandler (CmConnect connect) {
  char *name;

  name = CmConnectGetName( connect );
  CfgMsgAddInfo("CfgVpmDisconnectionHanlder> %s", name );

  return;
}


/*----------------------------------------------------------------------------*/
int main( int argc, char *argv[] ) {
  int i;
  char *tmp;
  double lTmo;
#ifdef USE_MW
  mwStatistics( 2 );
#endif


  if( CfgIdle( argc, argv, 1 ) == CFG_FAIL) exit(EXIT_FAILURE);

  CfgReachState( CfgServerConfigured );
  CfgReachState( CfgServerActive );
  CmConnectInstallDisconnectionHandler( CfgVpmDisconnectionHandler );
  CfgMsgAddInfo("After main loop - started ");
  tmp  = NULL;
  lTmo = -1;
  for( i = 0; !CfgFinished(); i++ ) {
    tmp = realloc( tmp, (i+1)*1024 );
    CfgMsgAddInfo("realloc %dKB", (i+1));
    if( CfgGetDebug() < 0 ) CfgLogFPrint("debug %d\n", CfgGetDebug());
    /*-------------------------------------------- Flush the message reporter */
    if( CfgGetRPeriodTime() ) { 
      lTmo = 1;
      CfgSetRMemoryFlag( 1 );
    } else {
      CfgSetRMemoryFlag( 0 ) ;
      lTmo = 1e-3;
    }
    CfgMsgAddUserInfo("%d - periodTime %g(s) - memoryFlag %d - tmo %g" , i,
		      CfgGetRPeriodTime(), CfgGetRMemoryFlag(), lTmo );
    CfgMsgSendWithTimeout( lTmo );
  }
  free(tmp);
  CfgMsgAddInfo("After main loop - Before exit");
  exit(EXIT_SUCCESS);
}

